<template>
  <div class="fr-container fr-p-0">
    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      message="La liste des utilisateurs n'a pas pu être chargée."
    />
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <div
      v-else-if="users"
      class="table-container"
      tabindex="0"
    >
      <div class="fr-table fr-table--bordered fr-table--no-caption">
        <table>
          <caption>
            Liste des utilisateurs
          </caption>
          <thead>
            <tr>
              <th scope="col">Nom</th>
              <th scope="col">Prénom</th>
              <th scope="col">Email</th>
              <th
                id="role-col"
                scope="col"
              >
                Rôle
              </th>
              <th
                id="authorisation-col"
                scope="col"
              >
                Aidant Connect
              </th>
              <th
                id="status-col"
                scope="col"
              >
                Accès
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="user in users"
              :key="user.id"
            >
              <td>{{ user.last_name }}</td>
              <td>{{ user.first_name }}</td>
              <td>{{ user.email }}</td>
              <td>
                <template v-if="authUserId !== user.id">
                  <form v-if="roles">
                    <AtomSelect
                      name="role"
                      label="Rôle"
                      :options="options"
                      :model-value="user.role.id"
                      required
                      :no-label="true"
                      labelled-by="role-col"
                      @change-value="onUpdateRole($event, user.id, user.email)"
                    />
                  </form>
                  <template v-else>{{ user.role.name }}</template>
                </template>
              </td>
              <td>
                <form>
                  <AtomCheckbox
                    :name="`aidant-connect-${user.id}`"
                    label="Aidant Connect"
                    :no-label="true"
                    :model-value="user.aidant_connect_authorisation"
                    labelled-by="authorisation-col"
                    @update:model-value="
                      onUpdateAidantConnect($event, user.id, user.email)
                    "
                  />
                </form>
              </td>
              <td>
                <form v-if="authUserId !== user.id">
                  <AtomToggle
                    :name="`status-${user.id}`"
                    label="Statut"
                    :no-label="true"
                    :checked-label="false"
                    labelled-by="status-col"
                    :checked="user.status === 'active'"
                    @toggle="onUpdateStatus($event, user.id, user.email)"
                  />
                </form>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { toOptions } from '~/utils'
  import { useAuthStore } from '~/store/auth'
  import { AlertType } from '~/utils/constants/alert'

  const props = defineProps({
    roles: {
      type: Array || Null,
      default: () => []
    },
    users: {
      type: Array || Null,
      default: () => []
    },
    pending: {
      type: Boolean,
      default: true
    },
    error: {
      type: Error || Null,
      default: null
    }
  })

  const { $apiRequest, $snackbar } = useNuxtApp()
  const authStore = useAuthStore()

  const options = computed(() => {
    return toOptions(props.roles, 'id', 'name')
  })

  const authUserId = computed(() => {
    return authStore.userId
  })

  async function onUpdateStatus(statusValue, userId, userEmail) {
    try {
      const res = await $apiRequest(`/users/${userId}`, {
        method: 'patch',
        data: { status: statusValue ? 'active' : 'suspended' }
      })

      if (res.status === 200) {
        if (statusValue) {
          $snackbar.success(`L'utilisateur ${userEmail} a été activé`)
        } else {
          $snackbar.success(`L'utilisateur ${userEmail} a été désactivé`)
        }
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error('La modification du statut a échoué.')
    }
  }

  async function onUpdateRole(roleValue, userId, userEmail) {
    try {
      const res = await $apiRequest(`/users/${userId}`, {
        method: 'patch',
        data: { role: roleValue }
      })

      if (res.status === 200) {
        $snackbar.success(`Le rôle de l'utilisateur ${userEmail} a été modifié`)
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error('La modification du rôle a échoué.')
    }
  }

  async function onUpdateAidantConnect(aidantConnectValue, userId, userEmail) {
    try {
      const res = await $apiRequest(`/users/${userId}`, {
        method: 'patch',
        data: { aidant_connect_authorisation: aidantConnectValue }
      })

      if (res.status === 200) {
        if (aidantConnectValue) {
          $snackbar.success(
            `L'habilitation Aidant Connect a été ajoutée à l'utilisateur ${userEmail}`
          )
        } else {
          $snackbar.success(
            `L'habilitation Aidant Connect a été retirée de l'utilisateur ${userEmail}`
          )
        }
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error(
        "La modification de l'habilitation Aidant Connect a échoué."
      )
    }
  }
</script>
